function kom_view_subscriptions()
{
	var viewelm = document.getElementById(kom_threadview_name);
	document.getElementById(kom_instantmessageview_name).style.display = "none";
	viewelm.style.display = "block";
	highlight_menu_item("meeting_subscriptions");

	viewelm.innerHTML = "Loading...";

	var allconfs = kom_command("list_all_conferences 1 0").split(KOM_GROUP_SEPARATOR);
	if (allconfs[0] != "OK")
	{
		allconfs = new Array();
	}
	else
	{
		for (var i = 1; i < allconfs.length; ++i)
			allconfs[i-1] = allconfs[i].split(KOM_RECORD_SEPARATOR);
		allconfs.pop();
	}

	// Remove all children
	viewelm.innerHTML = "<h2>Subscriptions</h2>";
	for (var i = 0; i < allconfs.length; ++i)
	{
		var subscribed = "";
		var disabled = "";
		if (parseInt(allconfs[i][2]))
			disabled = "DISABLED";
		for (var j = 0; subconfs && j < subconfs.length; ++j)
		{
			if (subconfs[j][0] == allconfs[i][0])
			{
				subscribed = "CHECKED";
				disabled = "";
			}
		}
		var elm = document.createElement("div");
		elm.innerHTML = "<input type='checkbox' id='kom_subscribe_cb_" + 
			allconfs[i][0] + "' "+subscribed+" "+disabled+
			" onClick='return toggle_subscribed(this, "+allconfs[i][0]+");'>"+
			" <label for='kom_subscribe_cb_"+allconfs[i][0]+"'>" + 
			allconfs[i][1] + "</label>";
		elm.innerHTML += " <a href='#ToggleDetails' onClick='toggle_confinfo_visible("+
			allconfs[i][0]+");return false;'>(Toggle details)</a>";

		elm.innerHTML += "<div id='sub_conf_info_"+allconfs[i][0]+
			"' class='kom_conference_details' style='display:none;'></div>";

		viewelm.appendChild(elm);
	}
	var elm = document.createElement("div");
	elm.setAttribute("class", "kom_create_conference");
	elm.innerHTML = "<form onkeyup='kom_cancel_key(event);' onsubmit='kom_create_conference(document.getElementById(\"kom_create_conf_name\").value);return false;'>\n" +
		"<div>Create new conference: " +
		"<input type='text' id='kom_create_conf_name' onkeyup='kom_cancel_key(event);'>"+
		"<input type='submit' value='Create'></div>\n</form>\n";
	viewelm.appendChild(elm);
}

function toggle_subscribed(elm, confid)
{
	var re;
	if (elm.checked)
	{
		// Subscribe to the conference
		re = kom_command("subscribe 1 -1 " + confid).split(KOM_GROUP_SEPARATOR);
	}
	else
	{
		if (!confirm("Are you sure you want to unsubscribe from " + kom_lookup_name(confid) + "?"))
			return false;
		re = kom_command("subscribe 0 -1 " + confid).split(KOM_GROUP_SEPARATOR);
	}
	if (re[0] != "OK")
		return false;
	// Insert into the list of conferences
	// Update the list to make sure it get's inserted in the correct position
	kom_update_conference_list();
	return true;
}

function kom_create_conference(name)
{
	if (kom_command("create_conference "+KOM_RECORD_SEPARATOR+name+KOM_RECORD_SEPARATOR).split(KOM_GROUP_SEPARATOR)[0] != "OK")
		alert("Failed to create conference");
	kom_view_subscriptions();
}

function toggle_confinfo_visible(id)
{
	var elm = document.getElementById("sub_conf_info_"+id);
	if (elm.style.display != "block")
	{
		elm.innerHTML = "Loading...";
		elm.style.display = "block";
		kom_begin_progress();
		var infoelm = document.createElement("div");
		var desc = kom_command("conference_info " + id).split(KOM_GROUP_SEPARATOR);
		if (desc[0] == "OK")
		{
			desc = desc[1].split(KOM_RECORD_SEPARATOR);

			if (parseInt(desc[0]))
			{
				infoelm.innerHTML += "<div class='kom_confinfo_data'><a href='#rename' onclick='kom_rename("+id+");return false;'>Rename conference</a></div>"
			}

			var subscribed = false;
			var sub_cb = document.getElementById("kom_subscribe_cb_" + id);
			if (sub_cb && sub_cb.checked)
				subscribed = true;
			// Subscription settings
			var subconf = null;
			if (subscribed)
			{
				// Find the subscribed entry
				for (var i = 0; i < subconfs.length && !subconf; ++i)
					if (subconfs[i][0] == id)
						subconf = subconfs[i];
			}
			if (subconf)
			{
				infoelm.innerHTML += "<div class='kom_confinfo_title'>Subscription settings:</div><div class='kom_confinfo_data'>"
				var checked = parseInt(subconf[4])?" CHECKED":"";
				infoelm.innerHTML += "<div><input id='kom_subscription_type_secret_"+id+"' type='checkbox'"+checked+" onclick='return kom_update_subscription_type("+id+");'> Secret</div>";
				checked = parseInt(subconf[5])?" CHECKED":"";
				infoelm.innerHTML += "<div><input id='kom_subscription_type_passive_"+id+"' type='checkbox'"+checked+" onclick='return kom_update_subscription_type("+id+");'> Ignore unread</div>";
				checked = parseInt(subconf[6])?" CHECKED":"";
				infoelm.innerHTML += "<div><input id='kom_subscription_type_imess_passive_"+id+"' type='checkbox'"+checked+" onclick='return kom_update_subscription_type("+id+");'> Ignore instant messages</div>";
				infoelm.innerHTML += "</div>\n";
			}

			// Supervisor, if any
			if (parseInt(desc[1]) > 0)
				infoelm.innerHTML += "<div class='kom_confinfo_title'>Supervisor:</div><div class='kom_confinfo_data'>" + kom_lookup_name(desc[1]) + "</div>\n";

			// Conference settings
			infoelm.innerHTML += "<div class='kom_confinfo_title'>Conference settings:</div>\n";
			var settingselm = document.createElement("div");
			settingselm.setAttribute("class", "kom_confinfo_data");
			var disabled = "";
			if (!parseInt(desc[0]))
				disabled = " DISABLED";
			var checked = parseInt(desc[3])?"CHECKED":"";
			settingselm.innerHTML += "<div><input id='kom_conf_type_subprot_"+id+"' type='checkbox' "+checked+disabled+" onclick='return kom_change_conference_type("+id+");'> Subscriptions protected</div>";
			checked = parseInt(desc[4])?"CHECKED":"";
			settingselm.innerHTML += "<div><input id='kom_conf_type_nocomm_"+id+"' type='checkbox' "+checked+disabled+" onclick='return kom_change_conference_type("+id+");'> Forbid comments</div>";
			checked = parseInt(desc[5])?"CHECKED":"";
			settingselm.innerHTML += "<div><input id='kom_conf_type_secret_"+id+"' type='checkbox' "+checked+disabled+" onclick='return kom_change_conference_type("+id+");'> Secret</div>";
			checked = parseInt(desc[6])?"CHECKED":"";
			settingselm.innerHTML += "<div><input id='kom_conf_type_anonok_"+id+"' type='checkbox' "+checked+disabled+" onclick='return kom_change_conference_type("+id+");'> Allow anonymous texts</div>";
			checked = parseInt(desc[7])?"CHECKED":"";
			settingselm.innerHTML += "<div><input id='kom_conf_type_nosecret_"+id+"' type='checkbox' "+checked+disabled+" onclick='return kom_change_conference_type("+id+");'> Forbid secret members</div>";
			infoelm.appendChild(settingselm);

			// Presentation
			var presentation = desc[2];
			presentation = presentation.replace(/.*\n/, "");
			if (parseInt(desc[0]))
			{
				infoelm.innerHTML += "<div class='kom_confinfo_title'>Description:</div>\n"+
					"<div class='kom_confinfo_data'>"+
					"<textarea id='kom_presentation_edit_"+id+"' cols='72' rows='20' onkeyup='kom_cancel_key(event);'>"+
					presentation+"</textarea>"+
					"<input type='button' onclick='kom_change_presentation("+id+");return false;' value='Change presentation'></div>\n";
			}
			else
			{
				presentation = kom_postprocess_message(presentation).replace(/\n/g, "<br>");
				if (presentation != "")
				{
					infoelm.innerHTML += "<div class='kom_confinfo_title'>Description:</div><div class='"+
						(presentation.indexOf("  ") >= 0 ? "kom_presentation_text_monospace" : "kom_presentation_text")+
						"'>" + presentation + "</div>\n";
				}
			}

			// User list
			var users = desc[8].split(",");
			infoelm.innerHTML += "<div class='kom_confinfo_title'>Users:</div>\n";
			if (users.length > 0 && users[0]!="")
			{
				// Prefetch all names
				kom_prefetch_names(users);
				var userlistelm = document.createElement("div");
				userlistelm.setAttribute("class", "kom_confinfo_data");
				var selm = document.createElement("select");
				selm.setAttribute("size", 6);
				selm.setAttribute("keyup", kom_cancel_key, false);
				selm.setAttribute("id", "kom_admin_member_list_" + id);
				for (var u = 0; u < users.length; ++u)
					selm.options[u] = new Option(kom_html_to_plain(kom_lookup_name(users[u])), users[u]);
				userlistelm.appendChild(selm);
				if (parseInt(desc[0]))
				{
					userlistelm.innerHTML += "<input onclick='kom_admin_sub_member("+id+");return false;' type='button' value='Remove Member'>";
				}
				infoelm.appendChild(userlistelm);
			}
			if (parseInt(desc[0]) || subscribed)
			{
				var newuserelm = document.createElement("div");
				newuserelm.setAttribute("class", "kom_confinfo_data");
				var selm = createConferenceSelector(false, true);
				newuserelm.appendChild(selm);
				newuserelm.innerHTML += "<input onclick='kom_admin_add_member("+id+",\""+selm.getAttribute("id")+"\");return false;' type='button' value='Add Member'>"
				if (parseInt(desc[0]))
				{
					newuserelm.innerHTML += "<input onclick='kom_change_supervisor("+id+",\""+selm.getAttribute("id")+"\");return false;' type='button' value='Change Supervisor'>"
				}
				infoelm.appendChild(newuserelm);
			}
		}
		elm.innerHTML = "";
		elm.appendChild(infoelm);
		kom_end_progress();
	}
	else
		elm.style.display = "none";
}

function kom_admin_sub_member(id)
{
	var old_member = document.getElementById("kom_admin_member_list_"+id);
	var komid = old_member.options[old_member.selectedIndex].value;
	if (komid == "")
		return;
	var re = kom_command("subscribe 0 " + komid + " " + id).split(KOM_GROUP_SEPARATOR);
	if (re[0] != "OK")
		return false;
	toggle_confinfo_visible(id);
	var elm = document.getElementById("sub_conf_info_"+id);
	elm.innerHTML = "";
	toggle_confinfo_visible(id);
}

function kom_admin_add_member(id, sel_id)
{
	var komid = getSelectedConference(sel_id);
	if (komid <= 0)
		return;
	var re = kom_command("subscribe 1 " + komid + " " + id).split(KOM_GROUP_SEPARATOR);
	if (re[0] != "OK")
		return false;
	toggle_confinfo_visible(id);
	var elm = document.getElementById("sub_conf_info_"+id);
	elm.innerHTML = "";
	toggle_confinfo_visible(id);
}

function kom_update_subscription_type(id)
{
	var secret = document.getElementById("kom_subscription_type_secret_"+id).checked;
	var passive = document.getElementById("kom_subscription_type_passive_"+id).checked;
	var instant_passive = document.getElementById("kom_subscription_type_imess_passive_"+id).checked;
	return kom_change_subscription_type(id, secret, passive, instant_passive);
}

function kom_change_subscription_type(id, secret, passive, instant_passive)
{
	var re = kom_command("change_subscription_type " + id + (secret?" 1":" 0") + (passive?" 1":" 0") + (instant_passive?" 1":" 0")).split(KOM_GROUP_SEPARATOR);
	if (re[0] != "OK")
		return false;
	kom_update_conference_list();
	if (current_conference >= 0)
	{
		if (current_thread >= 0)
		{
			kom_view_thread(current_thread, current_conference, true);
		}
		else
		{
			kom_view_conference(current_conference, current_conference_offset);
		}
	}
	return true;
}

function kom_change_conference_type(id)
{
	var prot = document.getElementById("kom_conf_type_subprot_"+id).checked;
	var no_comments = document.getElementById("kom_conf_type_nocomm_"+id).checked;
	var secret = document.getElementById("kom_conf_type_secret_"+id).checked;
	var anon_ok = document.getElementById("kom_conf_type_anonok_"+id).checked;
	var no_secret = document.getElementById("kom_conf_type_nosecret_"+id).checked;
	var re = kom_command("change_conference_type " + id + (prot?" 1":" 0") + (no_comments?" 1":" 0") + (secret?" 1":" 0") + (anon_ok?" 1":" 0") + (no_secret?" 1":" 0")).split(KOM_GROUP_SEPARATOR);
	if (re[0] != "OK")
	{
		return false;
	}
	return true;
}

function kom_view_users()
{
	var viewelm = document.getElementById(kom_threadview_name);
	document.getElementById(kom_instantmessageview_name).style.display = "none";
	viewelm.style.display = "block";
	highlight_menu_item("user_list");
	viewelm.innerHTML = "Loading...";
	
	var persons = kom_command("list_all_conferences 0 1").split(KOM_GROUP_SEPARATOR);
	if (persons[0] != "OK")
	{
		persons = new Array();
	}
	else
	{
		for (var i = 1; i < persons.length; ++i)
			persons[i-1] = persons[i].split(KOM_RECORD_SEPARATOR);
		persons.pop();
	}

	// Remove all children
	viewelm.innerHTML = "<h2>Users</h2>";
	for (var i = 0; i < persons.length; ++i)
	{
		var elm = document.createElement("div");
		//elm.setAttribute("id", "kom_subscribe"+cname[0]);
		elm.innerHTML = persons[i][1] + " <a href='#ToggleDetails' onClick='toggle_userinfo_visible("+persons[i][0]+");return false;'>(Toggle details)</a>";

		elm.innerHTML += "<div id='sub_user_info_"+persons[i][0]+"' class='kom_conference_details' style='display:none;'></div>";

		viewelm.appendChild(elm);
	}
}

function toggle_userinfo_visible(id)
{
	var elm = document.getElementById("sub_user_info_"+id);
	if (elm.style.display != "block")
	{
		elm.innerHTML = "";
		var desc = kom_command("conference_info " + id).split(KOM_GROUP_SEPARATOR);
		if (desc[0] == "OK")
		{
			desc = desc[1].split(KOM_RECORD_SEPARATOR);
			// Presentation
			var presentation = desc[2];
			presentation = presentation.replace(/.*\n/, "");
			if (parseInt(desc[0]))
			{
				elm.innerHTML += "<div class='kom_confinfo_data'><a href='#rename' onclick='kom_rename("+id+", 1);return false;'>Rename user</a></div>"
				if (presentation == "")
					presentation = "Name: \nAddress: \n\nTelephone: \nE-mail: \nWWW: \n\nOther: ";
				elm.innerHTML += "<div class='kom_confinfo_title'>Description:</div>\n"+
					"<div class='kom_confinfo_data'>"+
					"<textarea id='kom_presentation_edit_"+id+"' cols='72' rows='20' onkeyup='kom_cancel_key(event);'>"+
					presentation+"</textarea>"+
					"<input type='button' onclick='kom_change_presentation("+id+");return false;' value='Change presentation'></div>\n";
			}
			else
			{
				presentation = kom_postprocess_message(presentation).replace(/\n/g, "<br>");
				if (presentation != "")
				{
					elm.innerHTML += "<div class='kom_confinfo_title'>Description:</div><div class='"+
						(presentation.indexOf("  ") >= 0 ? "kom_presentation_text_monospace" : "kom_presentation_text")+
						"'>" + presentation + "</div>\n";
				}
				else
					elm.innerHTML += "There is no description of this user";
			}
		}
		elm.style.display = "block";
	}
	else
		elm.style.display = "none";
}

function kom_change_presentation(id)
{
	var text = document.getElementById("kom_presentation_edit_"+id).value.replace(/\r/g, "");
	var re = kom_command("change_presentation " + id + " " + KOM_RECORD_SEPARATOR + text + KOM_RECORD_SEPARATOR).split(KOM_GROUP_SEPARATOR);
	if (re[0] != "OK")
		alert("Failed to change the presentation");
	else
		alert("The presentation was changed");
}

function kom_rename(id, user)
{
	var old_name = kom_lookup_name(id);
	var new_name = prompt("Enter new name for conference \""+kom_html_to_plain(old_name)+"\"", kom_html_to_plain(old_name));
	if (!new_name || old_name == new_name)
		return;
	var re = kom_command("rename_conference " + id + " " + KOM_RECORD_SEPARATOR + new_name + KOM_RECORD_SEPARATOR).split(KOM_GROUP_SEPARATOR);
	if (re[0] != "OK")
	{
		alert("Failed to change the name");
		return;
	}
	if (user)
		kom_view_users();
	else
		kom_view_subscriptions();
}

function kom_change_supervisor(id, sel_id)
{
	var user = getSelectedConference(sel_id);
	if (user <= 0)
		return;
	if (!confirm("Are you sure you want to change the supervisor? You will no longer be able to make any change to this conference."))
		return;
	var re = kom_command("change_supervisor " + id + " " + user).split(KOM_GROUP_SEPARATOR);
	if (re[0] != "OK")
		alert("Failed to change supervisor");
	else
		kom_view_subscriptions();
}
