// KOM conference selctor "widget"

var confSelectorRunning = false;
var confSelectorId = 0;

function createConferenceSelector(confs, users)
{
	var elm = document.createElement("div");
	elm.setAttribute("name", "conference_selector");
	elm.setAttribute("id", "conference_selector_" + confSelectorId);
	elm.setAttribute("class", "kom_conference_selector");
	elm.setAttribute("selectedConference", 0);
	elm.setAttribute("prevValue", "");
	elm.setAttribute("searchValue", "");
	elm.setAttribute("wantConfs", confs?1:0);
	elm.setAttribute("wantUsers", users?1:0);
	elm.setAttribute("searchBoxCloseBlocked", 0);
	elm.setAttribute("selectorFocused", 0);
	elm.innerHTML = "<input class='kom_conf_select_input' type='text' autocomplete='off' onkeyup='kom_cancel_key(event);' onkeypress='return selectorKeyHandler(event, \"conference_selector_"+confSelectorId+"\");' onfocus='conferenceSelectorOnFocus(\"conference_selector_"+confSelectorId+"\");' onblur='conferenceSelectorOnBlur(\"conference_selector_"+confSelectorId+"\");'><img src='img/progress.png'><span></span><div class='kom_conf_select_match_list' onmousedown='blockSearchBoxClose(\"conference_selector_"+confSelectorId+"\", true);' onmouseup='blockSearchBoxClose(\"conference_selector_"+confSelectorId+"\", false);'></div>";
	++confSelectorId;
	if (!confSelectorRunning)
	{
		confSelectorRunning = true;
		setTimeout("updateAllConferenceSelectors();", 500);
	}
	return elm;
}

function getSelectedConference(id)
{
	var elm = document.getElementById(id);
	if (!elm)
		return 0;
	var selText = elm.getElementsByTagName("input")[0];
	elm.setAttribute("prevValue", selText.value);
	updateConferenceSelector(id);
	return elm.getAttribute("selectedConference");
}

function resetConferenceSelector(id)
{
	var elm = document.getElementById(id);
	var selText = elm.getElementsByTagName("input")[0];
	selText.value = "";
}

function blockSearchBoxClose(id, block)
{
	var elm = document.getElementById(id);
	elm.setAttribute("searchBoxCloseBlocked", block?1:0);
	if (!block && elm.getAttribute("selectorFocused") <= 0)
	{
		setTimeout("conferenceSelectorOnBlur('"+id+"');", 0);
	}
}

function conferenceSelectorOnBlur(id)
{
	var elm = document.getElementById(id);
	elm.setAttribute("selectorFocused", 0);
	if (elm.getAttribute("searchBoxCloseBlocked") > 0)
		return;
	var cnum = getSelectedConference(id);
	if (cnum>0)
	{
		selectConference(id, cnum);
	}
	// hide the search box
	setTimeout("document.getElementById('"+id+"').getElementsByTagName('div')[0].style.display = 'none';", 0);
	//var searchDiv = elm.getElementsByTagName("div")[0];
	//searchDiv.style.display = "none";
}

function conferenceSelectorOnFocus(id)
{
	var elm = document.getElementById(id);
	elm.setAttribute("selectorFocused", 1);
	var cnum = getSelectedConference(id);
	if (cnum<=0)
	{
		// if there is text, show the search box again
		var selText = elm.getElementsByTagName("input")[0];
		if (selText.value != "")
		{
			var searchDiv = elm.getElementsByTagName("div")[0];
			searchDiv.style.display = "block";
		}
	}
}
function updateAllConferenceSelectors()
{
	// Get all elements with name conference_selector
	var csels = document.getElementsByName("conference_selector");
	if (!csels)
	{
		setTimeout("updateAllConferenceSelectors();", 500);
		return;
	}
	for (var i = 0; i < csels.length; ++i)
	{
		updateConferenceSelector(csels[i].getAttribute("id"));
	}
	setTimeout("updateAllConferenceSelectors();", 500);
}

function updateConferenceSelector(id)
{
	var elm = document.getElementById(id);
	var selText = elm.getElementsByTagName("input")[0].value;
	var searchDiv = elm.getElementsByTagName("div")[0];
	var searchImg = elm.getElementsByTagName("img")[0];
	var okSpan = elm.getElementsByTagName("span")[0];
	var prevVal = elm.getAttribute("prevValue");
	var searchVal = elm.getAttribute("searchValue");
	var show_progress = false;
	if (selText != "" && selText != searchVal && selText == prevVal)
	{
		searchDiv.innerHTML = "*Searching*"
		searchDiv.style.display = "block";
		var wantConfs = elm.getAttribute("wantConfs");
		var wantUsers = elm.getAttribute("wantUsers");
		var matches = kom_command("list_all_conferences "+wantConfs+" "+wantUsers+" "+KOM_RECORD_SEPARATOR+selText+KOM_RECORD_SEPARATOR).split(KOM_GROUP_SEPARATOR);
		searchDiv.innerHTML = "";
		var users = document.createElement("div");
		var confs = document.createElement("div");
		users.innerHTML = "<div class='kom_conf_select_match_group_title'>Users</div>\n";
		confs.innerHTML = "<div class='kom_conf_select_match_group_title'>Conferences</div>\n";
		var usersValid = false;
		var confsValid = false;
		if (matches[0] == "OK")
		{
			if (matches.length != 2)
			{
				elm.setAttribute("selectedConference", -1);
				okSpan.setAttribute("class", "kom_conf_selector_status_invalid");
				okSpan.innerHTML = "Invalid";
			}
			for (var m = 1; m < matches.length; ++m)
			{
				var match = matches[m].split(KOM_RECORD_SEPARATOR);
				if (parseInt(match[3]))
				{
					usersValid = true;
					users.innerHTML += "<a href='#Select' class='kom_conf_select_match' name=\""+match[0]+"\" onclick='selectConference(\""+id+"\","+match[0]+");return false;'>" + match[1] + "</a><br>\n";
				}
				else
				{
					confsValid = true;
					confs.innerHTML += "<a href='#Select' class='kom_conf_select_match' name=\""+match[0]+"\" onclick='selectConference(\""+id+"\","+match[0]+");return false;'>" + match[1] + "</a><br>\n";
				}
				if (matches.length == 2)
				{
					elm.setAttribute("selectedConference", match[0]);
					okSpan.setAttribute("class", "kom_conf_selector_status_ok");
					okSpan.innerHTML = "OK";
				}
			}
		}
		else
		{
			elm.setAttribute("selectedConference", -1);
			okSpan.setAttribute("class", "kom_conf_selector_status_invalid");
			okSpan.innerHTML = "Invalid";
		}
		if (usersValid)
			searchDiv.appendChild(users);
		if (confsValid)
			searchDiv.appendChild(confs);
		elm.setAttribute("searchValue", selText);
	}
	else if (selText == "")
	{
		searchDiv.style.display = "none";
		elm.setAttribute("selectedConference", 0);
		okSpan.innerHTML = "";
	}
	else if (selText != searchVal)
	{
		show_progress = true;
		searchDiv.innerHTML = "";
		elm.setAttribute("selectedConference", -1);
		okSpan.setAttribute("class", "kom_conf_selector_status_unknown");
		okSpan.innerHTML = "Unknown";
		searchDiv.style.display = "block";
		elm.setAttribute("searchValue", "");
	}
	searchImg.style.visibility = show_progress ? "visible" : "hidden";
	elm.setAttribute("prevValue", selText);
}

function selectConference(id, cnum)
{
	var elm = document.getElementById(id);
	if (!elm)
		return;
	var selText = elm.getElementsByTagName("input")[0];
	var searchDiv = elm.getElementsByTagName("div")[0];
	var okSpan = elm.getElementsByTagName("span")[0];
	
	elm.setAttribute("selectedConference", cnum);
	selText.value = kom_html_to_plain(kom_lookup_name(cnum));
	// Don't trigger another search unless something changes
	elm.setAttribute("searchValue", selText.value);
	searchDiv.style.display="none";
	okSpan.setAttribute("class", "kom_conf_selector_status_ok");
	okSpan.innerHTML = "OK";
}

function selectorKeyHandler(e, id)
{
	var keynum;

	if(window.event) // IE
	{
		keynum = e.keyCode;
	}
	else if(e.which) // Netscape/Firefox/Opera
	{
		keynum = e.which;
	}

	if (keynum == 13 || keynum == 38 || keynum == 40)
	{
		var elm = document.getElementById(id);
		var searchDiv = elm.getElementsByTagName("div")[0];
		var links = searchDiv.getElementsByTagName("a");
		var selectedIndex = -1;
		for (var i = 0; i < links.length; ++i)
		{
			if (links[i].getAttribute("class") == "kom_conf_select_match_active")
				selectedIndex = i;
		}
		if (keynum == 38)
		{
			// Up
			if (selectedIndex > 0)
			{
				links[selectedIndex].setAttribute("class", "kom_conf_select_match");
				--selectedIndex;
				links[selectedIndex].setAttribute("class", "kom_conf_select_match_active");
				return false;
			}
		}
		else if (keynum == 40)
		{
			// Down
			if (selectedIndex < links.length-1)
			{
				if (selectedIndex >= 0)
					links[selectedIndex].setAttribute("class", "kom_conf_select_match");
				++selectedIndex;
				links[selectedIndex].setAttribute("class", "kom_conf_select_match_active");
				return false;
			}
		}
		else if (keynum == 13)
		{
			// Enter
			if (selectedIndex >= 0 && selectedIndex < links.length)
			{
				selectConference(id, links[selectedIndex].name);

				var instant_msg_view = document.getElementById("imessview_starter");
				if (searchDiv.style.display == "none" && instant_msg_view.style.display != "none") {
					var inputs = instant_msg_view.getElementsByTagName("input");
					var button = null;
					for (var i = 0; i < inputs.length; i++) {
						if (inputs[i].type == "button") {
							button = inputs[i];
						}
					}
					if (button) {
						button.click();
					}
				}
			}
			return false;
		}
	}
	return true;
}

